#include <stdbool.h>
#include <string.h>

bool isNonZeroDigit(char z)
{
  return z >= '1' && z <= '9';
}

bool isDigit(char z)
{
  return z >= '0' && z <= '9';
}

// Annahme: x ist Zeichenkette mit abschlieender Null
bool checkIfPhoneNumber(char x[])
{
  int length = strlen(x);
  if(x[0] != '0')
  {
    return false;
  }
  if(length < 2)
  {
    return false;
  }
  if(!isNonZeroDigit(x[1]))
  {
    return false;
  }
  if(length < 3)
  {
    return false;
  }
  if(!isDigit(x[2]))
  {
    return false;
  }
  
  if(length < 4)
  {
    return false;
  }
  int k = 3;
  if(isDigit(x[3]))
  {
    k = 4;
    if(length < 5)
    {
      return false;
    }     
    if(isDigit(x[4]))
    {
      k = 5;
    }
  } 

  if(length < k+1)
  {
    return false;
  }  
  if(x[k] != '/')
  {
    return false;
  }
  
  if(length < k+2)
  {
    return false;
  }
  if(!isNonZeroDigit(x[k+1]))
  {
    return false;
  } 
 
  for(int j = k+2; j < k+6; j++)
  {
    if(length < j+1)
    {
      return false;
    }
    if(!isDigit(x[j]))
    {
      return false;
    }
  }
  
  if(length > k+6+3)
  {
    return false;
  }
  
  for(int j = k+6; j < length; j++)
  {
    if(!isDigit(x[j]))
    {
      return false;
    }
  }
  
  return true;
}

int main( void )
{
  bool result = checkIfPhoneNumber("jhg");
  result = checkIfPhoneNumber("012435678");  
  result = checkIfPhoneNumber("012/435678");
  result = checkIfPhoneNumber("112/435678");
  result = checkIfPhoneNumber("012/035678");  
  result = checkIfPhoneNumber("012/4356780ghj");
  result = checkIfPhoneNumber("01234/43567803485kl76");
  result = checkIfPhoneNumber("01234/2345");  
  result = checkIfPhoneNumber("01234/23456");
  result = checkIfPhoneNumber("01234/234567");  
  result = checkIfPhoneNumber("01234/2345678");  
  result = checkIfPhoneNumber("01234/23456782");
  result = checkIfPhoneNumber("01234/234567822");
  result = checkIfPhoneNumber("01234/2345678228");
  result = checkIfPhoneNumber("01234/23456782257");  
  return 0;
}
